program tetris;
uses crt,graph;
const
 ArrowMoveDelay=50;
 maxMove=2;
 kolvo_punkt=3;
 name_punkt:array[1..kolvo_punkt] of string=('Start','Help','Exit');
 Figures:array[1..7,0..2,0..2] of byte=
 (((2,2,2),(0,2,0),(0,0,0)),
  ((0,2,0),(2,2,2),(0,0,0)),
  ((0,2,2),(0,2,0),(0,2,0)),
  ((2,2,0),(0,2,0),(0,2,0)),
  ((0,2,0),(2,2,2),(0,2,0)),
  ((0,2,0),(0,2,0),(0,2,0)),
  ((0,2,2),(0,2,0),(2,2,0)));
VAR
 T:array[1..10,1..20] of byte;
 CurrentFigure:byte;
 Fig:array[0..2,0..2] of byte;
 X,Y,Mline,Ld:byte;
 Dr,Md,del,moved,RotateFactor,score,punkt:integer;
 Fail,Quit,FigureLand,Lined,MP:boolean;
 ch:char;
 Vstr:string;


 procedure print_menu (numb_punkt:integer);
  const
    h_punkt=30;
    h_prom=20;
    w_punkt=100;
    x_beg=320-round(w_punkt/2);
    h_menu=h_punkt*kolvo_punkt+h_prom*(kolvo_punkt-1);
    y_beg=240-round(h_menu/2);
  var
    i,y1,x2,y2:integer;
  begin
    cleardevice;
    for i:=1 to kolvo_punkt do
      begin
        if i=numb_punkt then setfillstyle(1,red) else setfillstyle(1,green);
        y1:=y_beg+(h_punkt+h_prom)*(i-1);
        x2:=x_beg+w_punkt;
        y2:=y1+h_punkt;
        bar3d(x_beg,y1,x2,y2,10,true);
        settextjustify(1,1);
        outtextxy(320,y1+round(h_prom/2),name_punkt[i]);
      end;
  end;{Print_menu}

procedure ShowCubik(X,Y:byte;color:byte);
var I,J:byte;
begin
 SetColor(Color);
 For I:=3 to 17 do
 For J:=3 to 17 do
 begin
  putpixel(X*20+I-20,Y*20+J-20,color);
 end;
 SetColor(color+8);
 Rectangle(X*20-17,Y*20-17,X*20-3,Y*20-3);
end;{ShowCubik}


procedure ClearField;
VAR I,J:byte;
begin
For I:=1 to 10 do
 For J:=1 to 20 do
 If T[I,J]=2 then
    begin
         ShowCubik(I,J,0);
         T[I,J]:=0;
    end;
end;{ClearField}


Procedure InitTetrisTable;{Picyet obblast tetrica}
VAR
 I,J:byte;
begin
 For I:=1 to 10 do
 For J:=1 to 20 do
 begin
    ShowCubik(I,J,0);
    T[I,J]:=0;
 end;
 SetColor(9);
 Rectangle(0,0,200,400);
 For I:=1 to 10 do
 begin
      SetColor(3);
      Line(I*20,0,I*20,400);
      Line(0,I*20,200,I*20);
      Line(0,I*20+200,200,I*20+200);
      SetColor(1);
      Line(I*20+1,0,I*20+1,400);
      Line(0,I*20+1,200,I*20+1);
      Line(0,I*20+201,200,I*20+201);
      Line(I*20-1,0,I*20-1,400);
      Line(0,I*20-1,200,I*20-1);
      Line(0,I*20+199,200,I*20+199);
 end;
 For I:=1 to 10 do
 For J:=1 to 20 do
 T[I,J]:=0;{opystoshaet tablicy 1020}
end;{InitTetrisTable}


procedure ShowFigure(X,Y,FigNumb,color:byte);{Ricyet cami figyri}
VAR I,J:byte;
begin
 For I:=0 to 2 do
 For J:=0 to 2 do
 begin
      CASE RotateFactor of
      0:If Figures[FigNumb,I,J]>0 then
            begin
              ShowCubik(X+I,Y+J,Figures[FigNumb,I,J]*color);
              T[X+I,Y+J]:=Figures[FigNumb,I,J];
            end;
      1:If Figures[FigNumb,I,J]>0 then
            begin
              ShowCubik(X+2-J,Y+I,Figures[FigNumb,I,J]*color);
              T[X+2-J,Y+I]:=Figures[FigNumb,I,J];
            end;
      2:If Figures[FigNumb,I,J]>0 then
            begin
              ShowCubik(X+2-I,Y+2-J,Figures[FigNumb,I,J]*color);
              T[X+2-I,Y+2-J]:=Figures[FigNumb,I,J];
            end;
      3:If Figures[FigNumb,I,J]>0 then
            begin
              ShowCubik(X+J,Y+2-I,Figures[FigNumb,I,J]*color);
              T[X+J,Y+2-I]:=Figures[FigNumb,I,J];
            end;
      end;
 end;
end;{ShowFigure}


Function TestBoom:boolean;{Proverka na vozmojnost poleta}
VAR
 I,J:byte;
begin
 TestBoom:=False;
 For I:=1 to 10 do
 For J:=1 to 20 do
 begin
    If (T[I,J]=2){ect' li v kletke dvizys4ajaca figura}
       and
       (T[I,J+1]=1){i prepatstvie snizy}
       then TestBoom:=TRUE;
    If (T[I,J]=2) and (J=20) then TestBoom:=TRUE;
 end;
end;{TestBoom}


procedure Land;{prorisovka figyri na pole}
VAR I,J:byte;
begin
 For I:=1 to 10 do
 For J:=1 to 20 do
 begin
      if T[I,J]=2 then T[I,J]:=1;
 end;
end;{Land}


Procedure MoveLeft;{vozno li dvizenie nalevo}
VAR
 I,J:byte;
 TestLeft:boolean;
begin
 TestLeft:=False;
 For I:=1 to 10 do
 For J:=1 to 20 do
 begin
    If (T[I,J]=2){est' li v kletke dvizys4ajasa figyra}
       and
       (T[I-1,J]=1){i prepatstvie sleva}
       then TestLeft:=TRUE;
    If (T[I,J]=2) and (I=1) then TestLeft:=TRUE;
 end;
 If not TestLeft then X:=X-1;
 ClearField;
 ShowFigure(X,Y,CurrentFigure,CurrentFigure);
 Moved:=Moved+1;
 ch:=#0;
 delay(30);
end;{TestBoom}


Procedure MoveRight;{vozmozno lo dvizenie vpravo}
VAR
 I,J:byte;
 TestRight:boolean;
begin
 TestRight:=False;
 For I:=1 to 10 do
 For J:=1 to 20 do
 begin
    If (T[I,J]=2){est' li v kletke dvizys4ajasa figyra}
       and
       (T[I+1,J]=1){i prepatstvie sprava}
       then TestRight:=TRUE;
    If (T[I,J]=2) and (I=10) then TestRight:=TRUE;
 end;
 If Not TestRight then X:=X+1;
 ClearField;
 ShowFigure(X,Y,CurrentFigure,CurrentFigure);
 Moved:=Moved+1;  ch:=#0;  delay(30);
end;{MoveRight}


Procedure FastLand;
begin
 del:=0;
end;


function TestRotatable:boolean;{mozno li povora4ivat' figyry}
VAR I,J:integer;
begin
 TestRotatable:=TRUE;
 If X>8 then X:=8;
 If X<1 then X:=1;
 For I:=X to X+2 do
 For J:=Y to Y+2 do
 If T[I,J]=1 then TestRotatable:=False
end;


procedure Rotate;{povorot}
begin
 if TestRotatable then
 begin
    RotateFactor:=RotateFactor+1;
    If RotateFactor=4 then RotateFactor:=0;
    ClearField;
    ShowFigure(X,Y,CurrentFigure,CurrentFigure);
    ch:=#0;
    delay(30);
 end;
end;


Function TestLines:byte;{proverka zapolnenosti linii}
VAR
 I,J,Res:byte;
begin
 For J:=1 to 20 do
 begin
    Res:=0;
    for I:=1 to 10 do
        If T[I,J]>0 then Res:=res+1;
    If Res=10 then
              begin
               testLines:=J;
               Lined:=TRUE;
               break;
              end;
 end;
end;


Procedure DeleteLine(MLine:byte); {ydalenie linii}
VAR I,J:byte;
begin
 For J:=MLine downto 2 do
 For I:=1 to 10 do
 begin
    T[I,J]:=T[I,J-1];
    Showcubik(I,J,T[I,J]*7);
 end;
 For Dr:=320 downto 300 do
 begin
 sound(dr*random(30));
 delay(1);
 end;
 nosound;
end;


Procedure TestGameOver;{kapec}
VAR I,res:integer;
begin
 For I:=1 to 10 do
 begin
    If T[I,1]=1 then Fail:=TRUE;
 end;
end;

procedure lets_start;
begin
RANDOMIZE;
REPEAT{New Game}
 quit:=False;
 Fail:=false;
 InitTetrisTable;
 repeat{New Figure}
 ch:=#0;
 ClearField;
 X:=random(8)+1;
 CurrentFigure:=random(7)+1;
 RotateFactor:=0;
 For Y:=1 to 20 do
 begin
    if del>0 then ch:=#0;
    del:=30;
    Moved:=0;
    if del>0 then
                 if keypressed then ch:=readkey;
    ShowFigure(X,Y,currentfigure,currentfigure);
    if del>0 then For Md:=1 to 20 do
         begin
         if keypressed then ch:=readkey;
         Moved:=0;
         CASE ord(ch) of
            75:MoveLeft;
            77:MoveRight;
            80:FastLand;
            32:Rotate;
            end;
         delay(del*100);
         If Moved>MaxMove then
                           begin
                            delay(ArrowMoveDelay);
                            break;
                           end;
         end;
    FigureLand:=TestBoom;
    If FigureLand then begin Land;break; end;
    ClearField;
  end;
     TESTGAMEOVER;
     LD:=0;
     repeat{proverka na zapolnenie linii}
        Lined:=FALSE;
        MLine:=TestLines;
        If Lined then DeleteLine(Mline);
        If Lined then LD:=LD+1;
     until (not Lined) or (keypressed);
     CASE LD of
     1:score:=score+100;
     2:score:=score+400;
     3:score:=score+1200;
     4:score:=score+2500;
     end;
 SetColor(0);
 For MD:=210 to 640 do
 Line(Md,10,Md,100);
 SetColor(2);
 SetTextStyle(2,0,6);
 STR(score,Vstr);
 OuttextXY(250,20,Vstr);
 until (ch=#27) or Fail;{poka ne kapec, ili esc, deistvo prodolzaetsa}
 cleardevice;
 repeat
 SetTextStyle(4,0,4);
 SetColor(random(15));
 OutTextXY(280,100,'GAME OVER!  Play Again(Y/N)?');
 MP:=FALSE;
 until keypressed;
 if keypressed then
               begin
                ch:=readkey;
                If (ch=#110) or (ch=#78) then Quit:=TRUE;
                if (ch=#121) or (ch=#89) then lets_start;
               end
 until Quit or (ch=#27);
end;


procedure help;
begin
 setfillstyle(1,1);
 settextstyle(7,0,3);
 setbkcolor(yellow);
 setcolor(red);
 outtextxy(300,20,'KYPCOBAya PA6OTA COKOLOBA DMUTPiya');
 settextstyle(1,0,5);
 setcolor(green);
 outtextxy(300,50,'TETRIS');
 settextstyle(1,0,3);
 outtextxy(50,90,'Pravila');
 setcolor(blue);
 outtextxy(300,110,'Dla peredvizenija figyri nazimaite klavishi vpravo');
 outtextxy(230,130,'i vlevo, ili napravlaite zajimaja levujy klavishy mishi');
 outtextxy(215,170,'Dla bistrogo spyska - klavishy vniz');
 outtextxy(140,190,'Povorot figyri - Enter');
 ch:=readkey;
end;


begin
punkt:=1;
Dr:=0;
initgraph(dr,md,'g:\bpascal\bgi');
 repeat
  print_menu(punkt);
  ch:=readkey;
  if ord(ch)=0 then
   begin
    ch:=readkey;
    if ord(ch)=72 then
     if punkt=1 then punkt:=kolvo_punkt else dec(punkt);
    if ord(ch)=80 then
     if punkt=kolvo_punkt then punkt:=1 else inc(punkt);
   end;
 until ord(ch)=13;
 cleardevice;
 case punkt of
  1:lets_start;
  2:help;
 end
end.
